/*
 * Copyright (C) 1995, jack
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/* $Id: config.h,v 1.1 1995/09/12 20:33:58 jack Exp $ */

#ifndef config_h
#define config_h

#if defined (__HUMAN68K__)
#  define HAVE_UNISTD_H
#  undef HAVE_IO_H
#  define HAVE_SYS_STAT_H
#  undef HAVE_STAT_H
#  define HAVE_STRICMP
#  define HAVE_STRNICMP
#  define HAVE_STRLWR
#  define HAVE_STRDUP
#  define SUPPRESS_EXTENSION
#  define USE_ASM_ZENCODE
#  define USE_ASM_ZDECODE
#  undef USE_INLINE_UPDCRC
#  undef USE_C_UPDCRC
#  undef USE_C_MKCRC
#endif

#if defined (HAVE_UNISTD_H)
#  include <unistd.h>
#elif defined (HAVE_IO_H)
#  include <io.h>
#endif

#if defined (HAVE_SYS_STAT_H)
#  include <sys/stat.h>
#elif defined (HAVE_STAT_H)
#  include <stat.h>
#endif

#if !defined (HAVE_STRICMP)
#  if defined (HAVE_STRCASECMP)
#    define HAVE_STRICMP
#    define stricmp strcasecmp
#  endif
#endif

#if !defined (HAVE_STRNICMP)
#  if defined (HAVE_STRNCASECMP)
#    define HAVE_STRNICMP
#    define strnicmp strncasecmp
#  endif
#endif

#if defined (__HUMAN68K__) || defined (__MSDOS__)
#  define FOPEN_READTEXT "rt"
#  define FOPEN_READBINARY "rb"
#  define FOPEN_WRITETEXT "wt"
#  define FOPEN_WRITEBINARY "wb"
#  define FOPEN_APPENDTEXT "at"
#  define FOPEN_APPENDBINARY "ab"
#else
#  define FOPEN_READTEXT "r"
#  define FOPEN_READBINARY "r"
#  define FOPEN_WRITETEXT "w"
#  define FOPEN_WRITEBINARY "w"
#  define FOPEN_APPENDTEXT "a"
#  define FOPEN_APPENDBINARY "a"
#endif
#define FOPEN_READTEXT_PLUS FOPEN_READTEXT"+"
#define FOPEN_READBINARY_PLUS FOPEN_READBINARY"+"
#define FOPEN_WRITETEXT_PLUS FOPEN_WRITETEXT"+"
#define FOPEN_WRITEBINARY_PLUS FOPEN_WRITEBINARY"+"
#define FOPEN_APPENDTEXT_PLUS FOPEN_APPENDTEXT"+"
#define FOPEN_APPENDBINARY_PLUS FOPEN_APPENDBINARY"+"

#endif /* config_h */
