/*
 * Copyright (C) 1995, jack
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

static char rcsid[]= "$Id: cupdcrc.c,v 1.2 1995/09/19 23:02:26 jack Exp $";

#include "config.h"
#include "updcrc.h"

#if !defined (USE_INLINE_UPDCRC) && defined (USE_C_UPDCRC)
unsigned short
updcrc (char c, unsigned short crc)
{
  return crctable[(crc >> 8) & 0xff] ^ (crc << 8) ^ (unsigned char)c;
}

unsigned long
updcrc32 (char c, unsigned long crc)
{
  return crc32table[(crc ^ (unsigned char)c) & 0xff] ^ (crc >> 8);
}
#endif

#if defined (USE_C_MKCRC)
unsigned short
mkcrc (char *buffer, int len, unsigned short crc)
{
  while (--len >= 0)
    {
      crc = updcrc (*buffer & 0xff, crc);
      buffer++;
    }
  return crc;
}

unsigned long
mkcrc32 (char *buffer, int len, unsigned long crc)
{
  while (--len >= 0)
    {
      crc = updcrc32 (*buffer & 0xff, crc);
      buffer++;
    }
  return crc;
}
#endif
