/*
 * Copyright (C) 1995, jack
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/* $Id: utils.h,v 1.3 1995/11/01 15:12:14 jack Exp $ */

#ifndef utils_h
#define utils_h

#include <stdio.h>
#include <stddef.h>

#include "config.h"

#ifndef _VOLATILEFUNC
#  if defined (__GNUC__)
#    if (__GNUC__==2) && defined (__GNUC_MINOR__) && (__GNUC_MINOR__>=5)
#      define _VOLATILEFUNC(FUNC) FUNC __attribute__ ((noreturn))
#    else
#      define _VOLATILEFUNC(FUNC) __volatile__ FUNC
#    endif
#  else /* ! __GNUC__ */
#    define _VOLATILEFUNC(FUNC) FUNC
#  endif
#endif

#ifdef __cplusplus
extern "C"
{
#endif
extern char *toslash (char *fname);
extern char *get_basename (char *fname);
extern char *suppress_extension (char *fname);
#if !defined (HAVE_STRICMP) && !defined (HAVE_STRCASECMP)
extern int stricmp (char *s1, char *s2);
#endif
#if !defined (HAVE_STRNICMP) && !defined (HAVE_STRNCASECMP)
extern int strnicmp (char *s1, char *s2, int n);
#endif
#if !defined (HAVE_STRLWR)
extern char *strlwr (char *s);
#endif
#if !defined (HAVE_STRDUP)
extern char *strdup (char *s);
#endif
extern void _VOLATILEFUNC(fatal (char *format, ...));
extern void *xmalloc (size_t size);
extern void *xrealloc (void *p, size_t size);
extern char *xstrdup (char *s);
extern FILE *xfopen (char *fname, char *mode);
extern char *fgets_line (FILE *fp);
#ifdef __cplusplus
}
#endif

#endif /* utils_h */
