/*
 * Copyright (C) 1995, jack
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/* $Id: rsio.h,v 1.5 1995/10/29 10:07:46 jack Exp $ */

#ifndef rsio_h
#define rsio_h

#ifndef NO_RSIO_INLINE

#define IOCS_LOF232C (0x31)
#define IOCS_INP232C (0x32)
#define IOCS_ISNS232C (0x33)
#define IOCS_OSNS232C (0x34)
#define IOCS_OUT232C (0x35)

extern inline int
RSin (void)
{
  register int reg_d0 asm ("d0");

  asm volatile ("move.l %1,a0\n\t"
		"jsr (a0)\n\t"
		"tst.w d0\n\t"
		"jbne 1f\n\t"
		"jsr _RSinWait\n\t"
		"tst.l d0\n\t"
		"jbpl 1f\n\t"
		"moveq.l #-2,d0\n\t"
		"jbra 2f\n\t"
		"1:\n\t"
		"move.l %2,a0\n\t"
		"jsr (a0)\n\t"
		"and.w #$00ff,d0\n\t"
		"ext.l d0\n\t"
		"2:"
		: "=d" (reg_d0)
		: "g" (*(long *) (0x400 + IOCS_LOF232C * 4)),
		  "g" (*(long *) (0x400 + IOCS_INP232C * 4))
		: "d0", "d1", "d2", "a0", "a1", "a2");

  return reg_d0;
}

extern inline int
RSout (int ch)
{
  register int reg_d0 asm ("d0");

  asm volatile ("move.l %1,a0\n\t"
		"jsr (a0)\n\t"
		"tst.l d0\n\t"
		"jbne 1f\n\t"
		"jsr _RSoutWait\n\t"
		"tst.l d0\n\t"
		"jbpl 1f\n\t"
		"moveq.l #-2,d0\n\t"
		"jbra 2f\n\t"
		"1:\n\t"
		"move.l %2,a0\n\t"
		"move.w %3,d1\n\t"
		"jsr (a0)\n\t"
		"moveq.l #0,d0\n\t"
		"2:"
		: "=d" (reg_d0)
		: "g" (*(long *) (0x400 + IOCS_OSNS232C * 4)),
		  "g" (*(long *) (0x400 + IOCS_OUT232C * 4)),
		  "g" ((short) (ch))
		: "d0", "d1", "d2", "a0", "a1", "a2");

  return reg_d0;
}

#else

#ifdef __cplusplus
extern "C"
{
#endif
extern int RSin (void);
extern int RSout (int ch);
#ifdef __cplusplus
}
#endif

#endif /* NO_RSIO_INLINE */

#ifdef __cplusplus
extern "C"
{
#endif
extern int RSinit (void);
extern void RSend (void);
extern int RSKeyCheck (void);
extern int RSinWait (void);
extern int RSinSense (void);
extern int RSoutWait (void);
extern int RSoutSense (void);
extern void RSflush (void);
extern int RSprint (char *s);
#ifdef __cplusplus
}
#endif

extern int RSinWaitTime;

#endif /* rsio_h */
