/*
 * Copyright (C) 1995, jack
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/* $Id: updcrc.h,v 1.2 1995/09/19 23:03:02 jack Exp $ */

#ifndef updcrc_h
#define updcrc_h

#if !defined (USE_C_UPDCRC) && !defined (USE_C_MKCRC)
#  include "mkcrc.h"
#endif

#if defined (USE_C_UPDCRC)
extern unsigned short crctable[];
extern unsigned long crc32table[];
#if defined (USE_INLINE_UPDCRC)
#define updcrc(c, crc) \
  (crctable[(((crc) >> 8) & 0xff)] ^ ((crc) << 8) ^ ((unsigned char)c))
#define updcrc32(c, crc) \
  (crc32table[((crc) ^ ((unsigned char)c)) & 0xff] ^ ((crc) >> 8))
#else
extern unsigned short updcrc (char c, unsigned short crc);
extern unsigned long updcrc32 (char c, unsigned long crc);
#endif /* USE_INLINE_UPDCRC */
#endif /* USE_C_UPDCRC */

#if defined (USE_C_MKCRC)
extern unsigned short mkcrc (char *buffer, int len, unsigned short crc);
extern unsigned long mkcrc32 (char *buffer, int len, unsigned long crc);
#endif /* USE_C_MKCRC */

#endif /* updcrc_h */
