; Copyright (C) 1995, jack
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2, or (at your option)
; any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

; $Id: zedmkcrc.s,v 1.7 1995/11/14 09:13:33 jack Exp $
;
; unsigned short
; zedmkcrc (int *count, int *rc, int ctlesc, char *buffer, int len, unsigned short crc)

	.globl	_crc_table
	.globl	_crc32_table
	.globl	_RSKeyCheck
	.globl	_RSinWaitTime

IOCS_BITSNS	.equ	($04)
IOCS_LOF232C	.equ	($31)
IOCS_INP232C	.equ	($32)
IOCS_ONTIME	.equ	($7f)

RSin	.macro
	.local	RSinloop,RSinnext,RSintimeoutcheck,RSintimeout
	.local	RSinok,RSinend
	move.l	($400+IOCS_LOF232C*4).w,a0
	jsr	(a0)
	tst.w	d0
	jbne	RSinok
	move.w	sr,d2
	move.l	($400+IOCS_ONTIME*4).w,a0
	jsr	(a0)
	move.w	d2,sr
	move.l	d0,a2
RSinloop:
	moveq.l	#0,d1
	move.l	($400+IOCS_BITSNS*4).w,a0
	jsr	(a0)
	btst.l	#1,d0
	jbeq	RSinnext
	move.w	d2,-(sp)
	move.l	a2,-(sp)
	jsr	_RSKeyCheck
	move.l	(sp)+,a2
	move.w	(sp)+,d2
	tst.l	d0
	jbmi	RSintimeout
RSinnext:
	move.l	($400+IOCS_LOF232C*4).w,a0
	jsr	(a0)
	tst.w	d0
	jbne	RSinok
	move.l	($400+IOCS_ONTIME*4).w,a0
	jsr	(a0)
	move.w	d2,sr
	sub.l	a2,d0
	jbpl	RSintimeoutcheck
	add.l	#8640000,d0
	sub.l	#8640000,a2
RSintimeoutcheck:
	cmp.l	_RSinWaitTime,d0
	jblt	RSinloop
RSintimeout:
	moveq.l	#-2,d0
	jbra	RSinend
RSinok:
	move.l	($400+IOCS_INP232C*4).w,a0
	jsr	(a0)
	and.w	#$00ff,d0
RSinend:
	.endm

ZED	.equ	$01
CNT	.equ	$02
CAN	.equ	$18

xeRSin	.macro	mapreg
	.local	xeRSin_again,xeRSin_decode,xeRSin_notCAN,xeRSin_ZCRCE
	.local	xeRSin_ZCRCG,xeRSin_ZCRCQ,xeRSin_ZCRCW,xeRSin_ZRUB0
	.local	xeRSin_ZRUB1,xeRSin_error,xeRSin_normal,xeRSin_end
xeRSin_again:
	RSin
	move.b	(mapreg,d0.w),d1
	jbeq	xeRSin_end
	cmp.b	#ZED,d1
	jbne	xeRSin_again
xeRSin_decode:
	RSin
	jbmi	xeRSin_end
	cmp.b	#CAN,d0
	jbne	xeRSin_notCAN
	RSin
	jbmi	xeRSin_end
	cmp.b	#CAN,d0
	jbne	xeRSin_notCAN
	RSin
	jbmi	xeRSin_end
	cmp.b	#CAN,d0
	jbne	xeRSin_notCAN
	RSin
	jbmi	xeRSin_end
	cmp.b	#CAN,d0
	jbne	xeRSin_notCAN
	or.w	#$0100,d0		* GOTCAN
	jbra	xeRSin_end

xeRSin_notCAN:
	move.b	(mapreg,d0.w),d1
	jbne	xeRSin_decode
	cmp.b	#$68,d0
	jbcs	xeRSin_normal
	cmp.b	#$6d,d0
	jbhi	xeRSin_normal
	jbeq	xeRSin_ZRUB1
	sub.b	#$69,d0
	jbcs	xeRSin_ZCRCE
	jbeq	xeRSin_ZCRCG
	subq.b	#2,d0
	jbcs	xeRSin_ZCRCQ
	jbeq	xeRSin_ZCRCW
	jbra	xeRSin_ZRUB0

xeRSin_ZCRCE:
	move.w	#$0168,d0
	jbra	xeRSin_end

xeRSin_ZCRCG:
	move.w	#$0169,d0
	jbra	xeRSin_end

xeRSin_ZCRCQ:
	move.w	#$016a,d0
	jbra	xeRSin_end

xeRSin_ZCRCW:
	move.w	#$016b,d0
	jbra	xeRSin_end

xeRSin_ZRUB0:
	moveq.l	#$7f,d0
	jbra	xeRSin_end

xeRSin_ZRUB1:
	moveq.l	#0,d0
	not.b	d0
	jbra	xeRSin_end

xeRSin_error:
	moveq.l	#-1,d0
	jbra	xeRSin_end

xeRSin_normal:
	moveq.l	#$60,d1
	and.b	d0,d1
	cmp.b	#$40,d1
	jbne	xeRSin_error
	eor.w	d1,d0
xeRSin_end:
	.endm

SAVSIZE	.equ	(4+(4*7))

	.text
	.globl _zedmkcrc
	.even
_zedmkcrc:
	movem.l	d3-d6/a3-a5,-(sp)
	moveq.l	#0,d5
	move.w	SAVSIZE+4*5+2(sp),d5
	move.l	SAVSIZE+4*4(sp),d6
	jbeq	_zedmkcrc_length_error
	subq.l	#1,d6
	move.l	SAVSIZE+4*3(sp),a5
	lea.l	_crc_table,a4
	lea.l	_zed_ctrlmap,a3
	tst.l	SAVSIZE+4*2(sp)
	jbeq	1f
	lea.l	_zed_ctrlmapesc,a3
1:	move.w	#$ff00,d3
_zedmkcrc_loop:
	xeRSin	a3
	move.w	d0,d1
	and.w	d3,d1
	jbne	_zedmkcrc_got
	ror.w	#8,d5
	move.b	d5,d1
	add.w	d1,d1
	move.w	(a4,d1.w),d1
	move.b	d0,(a5)+
	move.b	d0,d5
	eor.w	d1,d5
	dbra.w	d6,_zedmkcrc_loop
	clr.w	d6
	subq.l	#1,d6
	jbcc	_zedmkcrc_loop

	xeRSin	a3
	move.w	d0,d1
	and.w	d3,d1
	jbne	_zedmkcrc_got
	moveq.l	#-1,d0
	jbra	_zedmkcrc_rc_end

_zedmkcrc_got:
	tst.w	d0
	jbmi	_zedmkcrc_count_end
	ext.l	d0
	jbra	_zedmkcrc_count_end

_zedmkcrc_length_error:
	move.l	SAVSIZE+4*3(sp),a5
	moveq.l	#-1,d0
	jbra	_zedmkcrc_count_end

_zedmkcrc_count_end:
	sub.l	SAVSIZE+4*3(sp),a5
	move.l	SAVSIZE+4*0(sp),a1
	move.l	a5,(a1)
_zedmkcrc_rc_end:
	move.l	SAVSIZE+4*1(sp),a2
	move.l	d0,(a2)
_zedmkcrc_end:
	move.l	d5,d0
	movem.l	(sp)+,d3-d6/a3-a5
	rts

; unsigned long
; zedmkcrc32 (int *count, int *rc, int ctlesc, char *buffer, int len, unsigned long crc)

	.text
	.globl _zedmkcrc32
	.even
_zedmkcrc32:
	movem.l	d3-d6/a3-a5,-(sp)
	move.l	SAVSIZE+4*5(sp),d5
	move.l	SAVSIZE+4*4(sp),d6
	jbeq	_zedmkcrc32_length_error
	subq.l	#1,d6
	move.l	SAVSIZE+4*3(sp),a5
	lea	_crc32_table,a4
	lea.l	_zed_ctrlmap,a3
	tst.l	SAVSIZE+4*2(sp)
	jbeq	1f
	lea.l	_zed_ctrlmapesc,a3
1:	move.w	#$ff00,d3
_zedmkcrc32_loop:
	xeRSin	a3
	move.w	d0,d1
	and.w	d3,d1
	jbne	_zedmkcrc32_got
	move.b	d0,d1
	move.b	d0,(a5)+
	eor.b	d5,d1
	add.w	d1,d1
	add.w	d1,d1
	move.l	(a4,d1.w),d1
	lsr.l	#8,d5
	eor.l	d1,d5
	dbra.w	d6,_zedmkcrc32_loop
	clr.w	d6
	subq.l	#1,d6
	jbcc	_zedmkcrc32_loop

	xeRSin	a3
	move.w	d0,d1
	and.w	d3,d1
	jbne	_zedmkcrc32_got
	moveq.l	#-1,d0
	jbra	_zedmkcrc32_rc_end

_zedmkcrc32_got:
	tst.w	d0
	jbmi	_zedmkcrc32_count_end
	ext.l	d0
	jbra	_zedmkcrc32_count_end

_zedmkcrc32_length_error:
	move.l	SAVSIZE+4*3(sp),a5
	moveq.l	#-1,d0
	jbra	_zedmkcrc32_count_end

_zedmkcrc32_count_end:
	sub.l	SAVSIZE+4*3(sp),a5
	move.l	SAVSIZE+4*0(sp),a1
	move.l	a5,(a1)
_zedmkcrc32_rc_end:
	move.l	SAVSIZE+4*1(sp),a2
	move.l	d0,(a2)
_zedmkcrc32_end:
	move.l	d5,d0
	movem.l	(sp)+,d3-d6/a3-a5
	rts

	.data
	.globl	_zed_ctrlmap
	.even
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; fff0H
_zed_ctrlmap:
;		 00  01  02  03  04  05  06  07  08  09  0a  0b  0c  0d  0e  0f
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 00H
	.dc.b	$00,CNT,$00,CNT,$00,$00,$00,$00,ZED,$00,$00,$00,$00,$00,$00,$00 ; 10H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 20H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 30H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 40H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 50H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 60H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 70H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 80H
	.dc.b	$00,CNT,$00,CNT,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 90H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; a0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; b0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; c0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; d0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; e0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; f0H

	.data
	.globl	_zed_ctrlmapesc
	.even
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; fff0H
_zed_ctrlmapesc:
;		 00  01  02  03  04  05  06  07  08  09  0a  0b  0c  0d  0e  0f
	.dc.b	CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT ; 00H
	.dc.b	CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,ZED,CNT,CNT,CNT,CNT,CNT,CNT,CNT ; 10H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 20H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 30H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 40H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 50H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 60H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 70H
	.dc.b	CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT ; 80H
	.dc.b	CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT,CNT ; 90H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; a0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; b0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; c0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; d0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; e0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; f0H

	.end
