; Copyright (C) 1995, jack
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2, or (at your option)
; any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

; $Id: zemkcrc.s,v 1.5 1995/10/17 13:44:59 jack Exp $
;
; unsigned short
; zemkcrc (int *lastsent, int ctlesc, char *buffer, int len, unsigned short crc)

	.globl	_crc_table
	.globl	_crc32_table
	.globl	_RSKeyCheck

IOCS_BITSNS	.equ	($04)
IOCS_OSNS232C	.equ	($34)
IOCS_OUT232C	.equ	($35)

RSout	.macro	ch
	.local	RSoutloop,RSoutok,RSoutend
RSoutloop:
	move.l	($400+IOCS_OSNS232C*4).w,a0
	jsr	(a0)
	tst.l	d0
	jbne	RSoutok
	moveq.l	#0,d1
	move.l	($400+IOCS_BITSNS*4).w,a0
	jsr	(a0)
	btst.l	#1,d0
	jbeq	RSoutloop
	jsr	_RSKeyCheck
	tst.l	d0
	jbeq	RSoutloop
	moveq.l	#-2,d0
	jbra	RSoutend
RSoutok:
	move.l	($400+IOCS_OUT232C*4).w,a0
	move.w	ch,d1
	jsr	(a0)
RSoutend:
	.endm

SAVSIZE	.equ	(4+(4*7))

	.text
	.globl _zemkcrc
	.even
_zemkcrc:
	movem.l	d3-d6/a3-a5,-(sp)
	moveq.l	#0,d4
	moveq.l	#0,d5
	move.w	SAVSIZE+4*4+2(sp),d5
	move.l	SAVSIZE+4*3(sp),d6
	jbeq	_zemkcrc_end
	subq.l	#1,d6
	move.l	SAVSIZE+4*2(sp),a5
	lea.l	_crc_table,a4
	lea.l	_ze_map,a3
	tst.l	SAVSIZE+4*1(sp)
	jbeq	1f
	lea.l	_ze_mapesc,a3
1:	clr.w	d3
_zemkcrc_loop:
	ror.w	#8,d5
	clr.w	d1
	move.b	d5,d1
	add.w	d1,d1
	move.w	(a4,d1.w),d1
	move.b	(a5)+,d5
	move.b	d5,d3
	move.b	(a3,d3.w),d3
	jbne	_zemkcrc_escape
_zemkcrc_no_escape:
	move.b	d5,d4
	eor.w	d1,d5
	RSout	d4
	dbra.w	d6,_zemkcrc_loop
	clr.w	d6
	subq.l	#1,d6
	jbcc	_zemkcrc_loop
_zemkcrc_set_end:
	move.l	SAVSIZE+4*0(sp),a0
	move.l	d4,(a0)
_zemkcrc_end:
	move.l	d5,d0
	movem.l	(sp)+,d3-d6/a3-a5
	rts

_zemkcrc_escape:
	cmp.b	#$0d,d3
	jbne	1f
	cmp.b	#'@',d4
	jbne	_zemkcrc_no_escape
	moveq.l	#$40,d3
	eor.b	d5,d3
1:	move.b	d3,d4
	eor.w	d1,d5
	RSout	#$18
	RSout	d3
	dbra.w	d6,_zemkcrc_loop
	clr.w	d6
	subq.l	#1,d6
	jbcc	_zemkcrc_loop
	jbra	_zemkcrc_set_end

; unsigned long
; zemkcrc32 (int *lastsent, int ctrlesc, char *buffer, int len, unsigned long crc)

	.text
	.globl _zemkcrc32
	.even
_zemkcrc32:
	movem.l	d3-d6/a3-a5,-(sp)
	moveq.l	#0,d4
	move.l	SAVSIZE+4*4(sp),d5
	move.l	SAVSIZE+4*3(sp),d6
	jbeq	_zemkcrc32_end
	subq.l	#1,d6
	move.l	SAVSIZE+4*2(sp),a5
	lea.l	_crc32_table,a4
	lea.l	_ze_map,a3
	tst.l	SAVSIZE+4*1(sp)
	jbeq	1f
	lea.l	_ze_mapesc,a3
1:	clr.w	d3
_zemkcrc32_loop:
	clr.w	d1
	move.b	(a5)+,d1
	move.w	d1,d3
	move.b	(a3,d3.w),d3
	jbne	_zemkcrc32_escape
_zemkcrc32_no_escape:
	move.b	d1,d4
	eor.b	d5,d1
	add.w	d1,d1
	add.w	d1,d1
	move.l	(a4,d1.w),d1
	lsr.l	#8,d5
	eor.l	d1,d5
	RSout	d4
	dbra.w	d6,_zemkcrc32_loop
	clr.w	d6
	subq.l	#1,d6
	jbcc	_zemkcrc32_loop
_zemkcrc32_set_end:
	move.l	SAVSIZE+4*0(sp),a0
	move.l	d4,(a0)
_zemkcrc32_end:
	move.l	d5,d0
	movem.l	(sp)+,d3-d6/a3-a5
	rts

_zemkcrc32_escape:
	cmp.b	#$0d,d3
	jbne	1f
	cmp.b	#'@',d4
	jbne	_zemkcrc32_no_escape
	moveq.l	#$40,d3
	eor.b	d1,d3
1:	move.b	d3,d4
	eor.b	d5,d1
	add.w	d1,d1
	add.w	d1,d1
	move.l	(a4,d1.w),d1
	lsr.l	#8,d5
	eor.l	d1,d5
	RSout	#$18
	RSout	d3
	dbra.w	d6,_zemkcrc32_loop
	clr.w	d6
	subq.l	#1,d6
	jbcc	_zemkcrc32_loop
	jbra	_zemkcrc32_set_end

	.data
	.globl	_ze_map
	.even
_ze_map:
;		 00  01  02  03  04  05  06  07  08  09  0a  0b  0c  0d  0e  0f
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0d,$00,$00 ; 00H
	.dc.b	$50,$51,$00,$53,$00,$00,$00,$00,$58,$00,$00,$00,$00,$00,$00,$00 ; 10H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 20H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 30H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 40H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 50H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 60H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 70H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$0d,$00,$00 ; 80H
	.dc.b	$d0,$d1,$00,$d3,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 90H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; a0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; b0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; c0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; d0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; e0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; f0H

	.data
	.globl	_ze_mapesc
	.even
_ze_mapesc:
;		 00  01  02  03  04  05  06  07  08  09  0a  0b  0c  0d  0e  0f
	.dc.b	$40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4a,$4b,$4c,$4d,$4e,$4f ; 00H
	.dc.b	$50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5a,$5b,$5c,$5d,$5e,$5f ; 10H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 20H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 30H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 40H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 50H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 60H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; 70H
	.dc.b	$c0,$c1,$c2,$c3,$c4,$c5,$c6,$c7,$c8,$c9,$ca,$cb,$cc,$cd,$ce,$cf ; 80H
	.dc.b	$d0,$d1,$d2,$d3,$d4,$d5,$d6,$d7,$d8,$d9,$da,$db,$dc,$dd,$de,$df ; 90H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; a0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; b0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; c0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; d0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; e0H
	.dc.b	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ; f0H

	.end
