/*
 * Copyright (C) 1995, jack
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/* $Id: zmodem.h,v 1.1 1995/09/12 20:38:23 jack Exp $ */

#ifndef zmodem_h
#define zmodem_h

/* following symbols from zmodem.h for rzsz */
#define ZPAD '*'
#define ZDLE 0x18
#define ZBIN 'A'
#define ZHEX 'B'
#define ZBIN32 'C'
#define ZMAXHLEN 16
#define ZMAXSPLEN 1024

#define ZRQINIT 0
#define ZRINIT 1
#define ZSINIT 2
#define ZACK 3
#define ZFILE 4
#define ZSKIP 5
#define ZNAK 6
#define ZABORT 7
#define ZFIN 8
#define ZRPOS 9
#define ZDATA 10
#define ZEOF 11
#define ZFERR 12
#define ZCRC 13
#define ZCHALLENGE 14
#define ZCOMPL 15
#define ZCAN 16
#define ZFREECNT 17
#define ZCOMMAND 18
#define ZSTDERR 19

#define ZCRCE 'h'
#define ZCRCG 'i'
#define ZCRCQ 'j'
#define ZCRCW 'k'
#define ZRUB0 'l'
#define ZRUB1 'm'

#define GOTOR 0400
#define GOTCRCE (ZCRCE|GOTOR)
#define GOTCRCG (ZCRCG|GOTOR)
#define GOTCRCQ (ZCRCQ|GOTOR)
#define GOTCRCW (ZCRCW|GOTOR)
#define GOTCAN  (CAN|GOTOR)

#define ZF0 3
#define ZF1 2
#define ZF2 1
#define ZF3 0
#define ZP0 0
#define ZP1 1
#define ZP2 2
#define ZP3 3

#define CANFDX  01
#define CANOVIO 02
#define CANBRK  04
#define CANRLE  010
#define CANLZW  020
#define CANFC32 040
#define ESCCTL  0100
#define ESC8    0200

#define ZATTNLEN 32

#define TESCCTL 0100
#define TESC8   0200

#define ZCBIN   1
#define ZCNL    2
#define ZCRESUM 3

#define ZMSKNOLOC 0200
#define ZMMASK 037
#define ZMNEWL 1
#define ZMCRC  2
#define ZMAPND 3
#define ZMCLOB 4
#define ZMNEW  5
#define ZMDIFF 6
#define ZMPROT 7
#define ZMCHNG 8

#define ZCACK1	1

/* special control code */
#define CR 0x0d
#define LF 0x0a
#define DLE 0x10
#define XON 0x11
#define XOFF 0x13
#define CAN 0x18
#define BS 0x08

#endif
