/*
 * Copyright (C) 1995, jack
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/* $Id: zwork.h,v 1.6 1995/11/05 21:06:20 jack Exp $ */

#ifndef zwork_h
#define zwork_h

#include <stdio.h>
#include "zmodem.h"

struct zwork
{
  /* Sending header buffer */
  char sbuf[4 + 4];		/* flag 4byte / CRC 4byte */
  int scrc32;

  /* Receiving header buffer */
  char rbuf[4 + 4];		/* flag 4byte / CRC 4byte */
  int rtype;
  int rcrc32;
  int rpos;

  /* ZRINIT flags */
  int rflags;

  /* ZSINIT flags */
  int zconv;
  int zmanag;
  int ztrans;

  /* Attention string */
  char attn[ZATTNLEN];

  /* ZFILE information */
  char fileinfo[ZMAXSPLEN];
  int infolen;

  /* Sending data buffer */
  char sdbuf[ZMAXSPLEN*2];
  char *sdbufp;

  /* Receiving data buffer */
  char rdbuf[ZMAXSPLEN*2];
  char *rdbufp;

  /* Receiving data count */
  int rdcount;

  /* Sending block size */
  int blksiz;

  /* Encode control character */
  int ctlesc;

  /* 32bit Frame Check Sending */
  int usefcs32;

  /* Last sent character */
  int lastsent;

  /* Last sync position */
  int lastsync;

  /* Retry counter */
  int retry;

  /* File name */
  char fname[FILENAME_MAX + 1];

  /* File size */
  int fsize;

  /* File timestamp */
  int ftime;

  /* File descriptor */
  int fd;

  /* File position */
  int fpos;

  /* File read buffer */
  char *buffer;

  /* Buffer size */
  int bufsiz;

  /* Buffer count */
  int bcount;

  /* Buffer position */
  int bpos;
};

extern struct zwork zwork;

extern int Zctlesc;
extern int Zresume;
extern int Zcheckcrc;
extern int Zshortcrc;
extern int Zhidebar;
extern int Zrwait;
extern char *Zrdir;
extern int Zlogtype;
extern char *Zlog;
extern char *Zloghost;
extern FILE *Zlogfp;
extern char Zattn[];
extern char Zconv;
extern char Zmanag;
extern char Ztrans;
extern int Znulls;

#endif /* zwork_h */
